﻿package actionscript {
	
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.desktop.*;
	
	public class DeZeeparelCMS extends MovieClip {
		
		private var settings:SettingsLoader;
		private var connection:NetConnection;
		
		private var WIDTH:int;
		private var HEIGHT:int;
		
		private var menuCollection:Array;
		private var currentIndex:int;
		private var insertParam:Object;
		
		private var deleteWindowOpen:Boolean=false;
		private var deleteWindow:NativeWindow;
		private var mcContent:MovieClip;
		
		public function DeZeeparelCMS():void {
			txtMenusWijzigen.visible=true;
			txtMenuToevoegen.visible=false;
			
			setStage();
			initMode();
			initApplication();
			stage.addEventListener(Event.RESIZE, stageResize);
		}
		
		private function initApplication():void {
			settings=SettingsLoader.getInstance();
			settings.addEventListener(SettingsLoader.SETTINGS_LOADED,settingsLoadedHandler);
			settings.loadXML();
		}
		
		private function initMenu():void {
			if(menuCollection[currentIndex]!=null){
				txtMenusWijzigen.txtMenu.txtNaam.text=menuCollection[currentIndex].titel;
				txtMenusWijzigen.txtMenu.txtGang1.text=menuCollection[currentIndex].gang1;
				txtMenusWijzigen.txtMenu.txtGang2.text=menuCollection[currentIndex].gang2;
				txtMenusWijzigen.txtMenu.txtGang3.text=menuCollection[currentIndex].gang3;
				
				setMenusButtons();
			}
		}
		
		private function initMenuBtn():void {
			if(menuCollection[currentIndex]!=null){
				txtMenusWijzigen.btnSend.addEventListener(MouseEvent.CLICK,wijzigenHandler);
				txtMenusWijzigen.btnDelete.addEventListener(MouseEvent.CLICK,deleteHandler);
				
				txtMenusWijzigen.btnSend.mouseChildren=false;
				txtMenusWijzigen.btnDelete.mouseChildren=false;
				txtMenusWijzigen.btnDelete.buttonMode=true;
				txtMenusWijzigen.btnSend.buttonMode=true;
			}
			
			txtMenuToevoegen.btnSend.addEventListener(MouseEvent.CLICK,toevoegenHandler);
			txtMenuToevoegen.btnSend.mouseChildren=false;
			txtMenuToevoegen.btnSend.buttonMode=true;
		}
		
		private function wijzigenHandler(e:MouseEvent):void {
			txtMenusWijzigen.gewijzigdMC.alpha=0;
			
			var txtNaam:String=txtMenusWijzigen.txtMenu.txtNaam.text;
			var txtGang1:String=txtMenusWijzigen.txtMenu.txtGang1.text;
			var txtGang2:String=txtMenusWijzigen.txtMenu.txtGang2.text;
			var txtGang3:String=txtMenusWijzigen.txtMenu.txtGang3.text;
			
			if(txtNaam!="" && txtGang1!="" && txtGang2!="" && txtGang3!=""){
				txtMenusWijzigen.veldenInvullenMC.alpha=0;
				menuWijzigen();
			} else {
				txtMenusWijzigen.veldenInvullenMC.alpha=1;
			}
		}
		
		private function menuWijzigen():void {
			menuCollection[currentIndex].titel=txtMenusWijzigen.txtMenu.txtNaam.text;
			menuCollection[currentIndex].gang1=txtMenusWijzigen.txtMenu.txtGang1.text;
			menuCollection[currentIndex].gang2=txtMenusWijzigen.txtMenu.txtGang2.text;
			menuCollection[currentIndex].gang3=txtMenusWijzigen.txtMenu.txtGang3.text;
			
			var param:Object = new Object();
			param.id=menuCollection[currentIndex].id;
			param.titel=escape(menuCollection[currentIndex].titel);
			param.gang1=escape(menuCollection[currentIndex].gang1);
			param.gang2=escape(menuCollection[currentIndex].gang2);
			param.gang3=escape(menuCollection[currentIndex].gang3);
			
			var saveResp:Responder=new Responder(saveResultHandler,saveFaultHandler);
			connection.call("zeeparelService.updateMenu",saveResp,param);
		}
		
		private function saveResultHandler(success:Boolean):void {
			trace("UPDATE GESLAAGD");
			
			txtMenusWijzigen.gewijzigdMC.alpha=1;
		}
		private function saveFaultHandler(obj:Object):void {
			trace("fout bij updaten");
		}
		
		private function deleteHandler(e:MouseEvent):void {
			if (! deleteWindowOpen) {
				//AIR specifieke opties instellen van een nieuw (image)window
				var deleteWindowOptions:NativeWindowInitOptions = new NativeWindowInitOptions();
				deleteWindowOptions.maximizable=false;
				deleteWindowOptions.minimizable=false;
				deleteWindowOptions.resizable=false;
				deleteWindowOptions.type=NativeWindowType.NORMAL;
				//opties toekennen + bijkomende settings instellen
				deleteWindow=new NativeWindow(deleteWindowOptions);
				deleteWindow.width=246;
				deleteWindow.height=130;
				deleteWindow.y=this.stage.nativeWindow.y+HEIGHT/2-65;
				deleteWindow.x=this.stage.nativeWindow.x+WIDTH/2-123;
				deleteWindow.title="Menu verwijderen?";

				deleteWindow.stage.scaleMode=StageScaleMode.NO_SCALE;
				deleteWindow.stage.align=StageAlign.TOP_LEFT;
				
				mcContent = deleteWindow.stage.addChild(new DeleteWindowContent()) as MovieClip;

				deleteWindow.addEventListener(Event.CLOSE,closeHandler);
				deleteWindow.activate();
				deleteWindowOpen=true;
				
				initDeleteWindow();
			}
		}
		
		private function initDeleteWindow():void {
			mcContent.btnAnnuleer.buttonMode=true;
			mcContent.btnVerwijder.buttonMode=true;
			
			mcContent.btnAnnuleer.addEventListener(MouseEvent.CLICK,closeDeleteWindow);
			mcContent.btnVerwijder.addEventListener(MouseEvent.CLICK,verwijderMenu);
		}
		
		private function closeDeleteWindow(e:MouseEvent):void {
			deleteWindow.close();
			deleteWindowOpen=false;
		}
		
		private function verwijderMenu(e:MouseEvent):void {
			deleteWindow.close();
			deleteWindowOpen=false;
			
			var deleteResp:Responder=new Responder(deleteMenuHandler,deleteMenuFaultHandler);
			connection.call("zeeparelService.deleteMenu",deleteResp,menuCollection[currentIndex].id);
		}
		
		private function deleteMenuHandler(obj:Object):void {
			trace("DELETE GESLAAGD");
			
			menuCollection.splice(currentIndex,1);
			
			if(menuCollection.length==0){
				txtMenusWijzigen.txtMenu.txtNaam.text="";
				txtMenusWijzigen.txtMenu.txtGang1.text="";
				txtMenusWijzigen.txtMenu.txtGang2.text="";
				txtMenusWijzigen.txtMenu.txtGang3.text="";
				
				txtMenusWijzigen.btnSend.removeEventListener(MouseEvent.CLICK,wijzigenHandler);
				txtMenusWijzigen.btnDelete.removeEventListener(MouseEvent.CLICK,deleteHandler);
			}
			
			initMenu();
		}
		
		private function deleteMenuFaultHandler(obj:Object):void {
			trace("Fout bij deleten");
		}
		
		private function closeHandler(e:Event){
			deleteWindowOpen=false;
		}
		
		private function toevoegenHandler(e:MouseEvent):void {
			txtMenuToevoegen.toegevoegdMC.alpha=0;
			
			var txtNaam:String=txtMenuToevoegen.txtMenu.txtNaam.text;
			var txtGang1:String=txtMenuToevoegen.txtMenu.txtGang1.text;
			var txtGang2:String=txtMenuToevoegen.txtMenu.txtGang2.text;
			var txtGang3:String=txtMenuToevoegen.txtMenu.txtGang3.text;
			
			if(txtNaam!="" && txtGang1!="" && txtGang2!="" && txtGang3!=""){
				txtMenuToevoegen.veldenInvullenMC.alpha=0;
				menuToevoegen();
			} else {
				txtMenuToevoegen.veldenInvullenMC.alpha=1;
			}
		}
		
		private function menuToevoegen():void {
			var tempMenu:Menu = new Menu();
			tempMenu.titel=txtMenuToevoegen.txtMenu.txtNaam.text;
			tempMenu.gang1=txtMenuToevoegen.txtMenu.txtGang1.text;
			tempMenu.gang2=txtMenuToevoegen.txtMenu.txtGang2.text;
			tempMenu.gang3=txtMenuToevoegen.txtMenu.txtGang3.text;
			
			menuCollection.push(tempMenu);
			
			insertParam = new Object();
			insertParam.titel=escape(tempMenu.titel);
			insertParam.gang1=escape(tempMenu.gang1);
			insertParam.gang2=escape(tempMenu.gang2);
			insertParam.gang3=escape(tempMenu.gang3);
			
			var addResp:Responder=new Responder(addResultHandler,addFaultHandler);
			connection.call("zeeparelService.insertMenu",addResp,insertParam);
		}
		
		private function addResultHandler(success:Boolean):void {
			trace("INSERT GESLAAGD");
			
			txtMenuToevoegen.toegevoegdMC.alpha=1;
			txtMenuToevoegen.txtMenu.txtNaam.text="";
			txtMenuToevoegen.txtMenu.txtGang1.text="";
			txtMenuToevoegen.txtMenu.txtGang2.text="";
			txtMenuToevoegen.txtMenu.txtGang3.text="";
			
			var getMenuResp:Responder=new Responder(getMenuHandler,addFaultHandler);
			connection.call("zeeparelService.getIdFromMenu",getMenuResp,insertParam);
		}
		private function addFaultHandler(obj:Object):void {
			trace("fout bij inserten");
		}
		
		private function getMenuHandler(obj:Object):void {
			menuCollection[menuCollection.length-1].id=obj;
			
			initMenu();
			initMenuBtn();
		}
		
		private function initMode():void {
			btnMenusWijzigen.addEventListener(MouseEvent.CLICK,toggleMode1);
			btnMenuToevoegen.addEventListener(MouseEvent.CLICK,toggleMode2);
			
			btnMenusWijzigen.buttonMode=true;
			btnMenuToevoegen.buttonMode=true;
			
			btnMenusWijzigen.mouseChildren=false;
			btnMenuToevoegen.mouseChildren=false;
		}
		
		private function toggleMode1(e:MouseEvent):void {
			txtMenusWijzigen.gewijzigdMC.alpha=0;
			txtMenuToevoegen.visible=false;
			txtMenusWijzigen.visible=true;
		}
		private function toggleMode2(e:MouseEvent):void {
			txtMenuToevoegen.toegevoegdMC.alpha=0;
			txtMenuToevoegen.visible=true;
			txtMenusWijzigen.visible=false;
		}
		
		private function setMenusButtons():void {
			if (currentIndex<=0) {
				txtMenusWijzigen.btnLeft.alpha=0.5;
				txtMenusWijzigen.btnLeft.buttonMode=false;
				txtMenusWijzigen.btnLeft.removeEventListener(MouseEvent.ROLL_OVER,rollOverHandler);
				txtMenusWijzigen.btnLeft.removeEventListener(MouseEvent.ROLL_OUT,rollOutHandler);
				txtMenusWijzigen.btnLeft.removeEventListener(MouseEvent.CLICK,leftClickHandler);
			} else {
				txtMenusWijzigen.btnLeft.alpha=1;
				txtMenusWijzigen.btnLeft.buttonMode=true;
				txtMenusWijzigen.btnLeft.addEventListener(MouseEvent.ROLL_OVER,rollOverHandler);
				txtMenusWijzigen.btnLeft.addEventListener(MouseEvent.ROLL_OUT,rollOutHandler);
				txtMenusWijzigen.btnLeft.addEventListener(MouseEvent.CLICK,leftClickHandler);
			}

			if (currentIndex>=menuCollection.length-1) {
				txtMenusWijzigen.btnRight.alpha=0.5;
				txtMenusWijzigen.btnRight.buttonMode=false;
				txtMenusWijzigen.btnRight.removeEventListener(MouseEvent.ROLL_OVER,rollOverHandler);
				txtMenusWijzigen.btnRight.removeEventListener(MouseEvent.ROLL_OUT,rollOutHandler);
				txtMenusWijzigen.btnRight.removeEventListener(MouseEvent.CLICK,rightClickHandler);
			} else {
				txtMenusWijzigen.btnRight.alpha=1;
				txtMenusWijzigen.btnRight.buttonMode=true;
				txtMenusWijzigen.btnRight.addEventListener(MouseEvent.ROLL_OVER,rollOverHandler);
				txtMenusWijzigen.btnRight.addEventListener(MouseEvent.ROLL_OUT,rollOutHandler);
				txtMenusWijzigen.btnRight.addEventListener(MouseEvent.CLICK,rightClickHandler);
			}
		}

		private function rollOverHandler(e:MouseEvent):void {
			e.currentTarget.alpha=0.75;
		}
		private function rollOutHandler(e:MouseEvent):void {
			e.currentTarget.alpha=1;
		}

		private function leftClickHandler(e:MouseEvent):void {
			txtMenusWijzigen.veldenInvullenMC.alpha=0;
			txtMenusWijzigen.gewijzigdMC.alpha=0;
			currentIndex=currentIndex-1;
			initMenu();
		}

		private function rightClickHandler(e:MouseEvent):void {
			txtMenusWijzigen.veldenInvullenMC.alpha=0;
			txtMenusWijzigen.gewijzigdMC.alpha=0;
			currentIndex=currentIndex+1;
			initMenu();
		}
		
		private function settingsLoadedHandler(e:Event):void {
			connection = new NetConnection();
			connection.connect(settings.httproot);
			
			var getAllMenusResponder:Responder=new Responder(getAllMenusResponderHandler,getAllMenusResponderFault);
			connection.call("zeeparelService.getAllMenus",getAllMenusResponder);
		}
		
		private function getAllMenusResponderHandler(obj:Object):void {
			menuCollection=new Array();

			var resultArray:Array=obj.serverInfo.initialData as Array;

			for each (var item:Array in resultArray) {
				var tempMenu:Menu=new Menu();

				tempMenu.id=item[0];
				tempMenu.titel=unescape(item[1]);
				tempMenu.gang1=unescape(item[2]);
				tempMenu.gang2=unescape(item[3]);
				tempMenu.gang3=unescape(item[4]);

				menuCollection.push(tempMenu);
			}
			
			currentIndex=0;
			
			initMenuBtn();
			initMenu();
		}
		
		private function getAllMenusResponderFault(obj:Object):void {
			trace("fault");
		}
		
		private function setStage():void {
			stage.scaleMode=StageScaleMode.NO_SCALE;
			stage.align=StageAlign.TOP_LEFT;

			WIDTH=stage.stageWidth;
			HEIGHT=stage.stageHeight;
		}

		private function stageResize(e:Event):void {
			setStage();
			
			barsMC.width=WIDTH;
			topMC.height=HEIGHT;
		}
	}
}