﻿package actionscript{

	import flash.display.*;
	import flash.events.*;
	import flash.ui.Keyboard;
	import flash.net.*;
	import flash.geom.Matrix;
	import flash.geom.Transform;
	import org.swxformat.*;
	import com.greensock.*;
	import com.greensock.easing.*;

	public class Application extends MovieClip {

		private var rootPath:String="http://xml.weather.yahoo.com/forecastrss?p=";
		private var rootPathImage:String="http://l.yimg.com/a/i/us/nws/weather/gr/";
		private var weerXML:XML;
		private var locationsArray:Array;
		private var locationCode:String;
		private var tryCity:Boolean=false;
		private var landCode:String="be";
		
		private var isFlipped:Boolean=false;

		private var iWeatherWidth:int;
		private var iWeatherHeight:int;
		private var iWeatherLeft:int;
		private var iWeatherTop:int;

		private var widgetWidth:int;
		private var widgetHeight:int;
		private var widgetLeft:int;
		private var widgetTop:int;

		private var closeWidth:int;
		private var closeHeight:int;
		private var closeLeft:int;
		private var closeTop:int;

		private var imageNowX:int;
		private var imageTodayX:int;
		private var imageTomorrowX:int;

		public function Application():void {
			initWidget();
			initSharedObject();
			loadWeer(locationsArray[locationsArray.length-1].locationCode);
		}

		private function initWidget():void {
			this.firstViewMC.widgetFirstMC.addEventListener(MouseEvent.MOUSE_DOWN,dragHandler);
			this.firstViewMC.closeMC.addEventListener(MouseEvent.MOUSE_UP,closeNow);
			this.firstViewMC.widgetFirstMC.optionsMC.addEventListener(MouseEvent.MOUSE_UP,flipWidget);
			this.firstViewMC.closeMC.buttonMode=true;
			this.firstViewMC.widgetFirstMC.txtCode.addEventListener(MouseEvent.MOUSE_DOWN,codeHandler);

			this.secondViewMC.widgetSecondMC.addEventListener(MouseEvent.MOUSE_DOWN,dragHandler);
			this.secondViewMC.closeMC.addEventListener(MouseEvent.MOUSE_UP,closeNow);
			this.secondViewMC.widgetSecondMC.readyMC.addEventListener(MouseEvent.MOUSE_UP,flipWidgetBack);
			this.secondViewMC.closeMC.buttonMode=true;
			this.secondViewMC.visible=false;

			this.iWeatherWidth=this.firstViewMC.width;
			this.iWeatherHeight=this.firstViewMC.height;
			this.iWeatherLeft=this.firstViewMC.x;
			this.iWeatherTop=this.firstViewMC.y;

			this.widgetWidth=this.firstViewMC.widgetFirstMC.width;
			this.widgetHeight=this.firstViewMC.widgetFirstMC.height;
			this.widgetLeft=this.firstViewMC.widgetFirstMC.x;
			this.widgetTop=this.firstViewMC.widgetFirstMC.y;

			this.closeWidth=this.firstViewMC.closeMC.width;
			this.closeHeight=this.firstViewMC.closeMC.height;
			this.closeLeft=this.firstViewMC.closeMC.x;
			this.closeTop=this.firstViewMC.closeMC.y;

			this.imageNowX=this.firstViewMC.widgetFirstMC.imageNowMC.x;
			this.imageTodayX=this.firstViewMC.widgetFirstMC.imageTodayMC.x;
			this.imageTomorrowX=this.firstViewMC.widgetFirstMC.imageTomorrowMC.x;

			this.addEventListener(KeyboardEvent.KEY_UP, keyHandler);
		}

		private function initSharedObject():void {
			//shared object opvragen en controleren op hij data bevat
			//als dit object al bestaat wordt hij ingelezen, als hij niet bestaat wordt hij aangemaakt
			var so:SharedObject=SharedObject.getLocal("iWeather");
			if (so.size==0) {
				locationsArray = new Array();

				var we0:Weer = new Weer();
				var we1:Weer = new Weer();
				var we2:Weer = new Weer();
				var we3:Weer = new Weer();
				var we4:Weer = new Weer();
				var we5:Weer = new Weer();

				we0.locationCode="bexx0022";
				we0.stad="Oostende Airport, BE";

				we1.locationCode="bexx0003";
				we1.stad="Antwerp, BE";

				we2.locationCode="bexx0007";
				we2.stad="Dendermonde, BE";

				we3.locationCode="bexx0008";
				we3.stad="Gent, BE";

				we4.locationCode="bexx0021";
				we4.stad="Koksijde, BE";

				we5.locationCode="bexx0005";
				we5.stad="Brussels, BE";

				locationsArray.push(we0);
				locationsArray.push(we1);
				locationsArray.push(we2);
				locationsArray.push(we3);
				locationsArray.push(we4);
				locationsArray.push(we5);
			} else {
				parsenSharedData();
			}
		}

		private function parsenSharedData():void {
			var so:SharedObject=SharedObject.getLocal("iWeather");
			locationsArray=so.data.locations as Array;
			for (var i=locationsArray.length-1; i>=0; i--) {
				trace(locationsArray[i].locationCode+" "+locationsArray[i].stad);
			}
		}

		private function resetMatrix(curMc:DisplayObject) {
			var xPos:int=this.iWeatherLeft;
			var yPos:int=this.iWeatherTop;
			curMc.transform.matrix = new Matrix();
			curMc.x=xPos;
			curMc.y=yPos;
		}

		private function keyHandler(event:KeyboardEvent):void {
			if (event.keyCode==Keyboard.ENTER&&this.firstViewMC.widgetFirstMC.txtCode.text!="") {
				loadWeer(this.firstViewMC.widgetFirstMC.txtCode.text);
			}
			
			if(this.firstViewMC.widgetFirstMC.txtCode.text.length>4){
				var citiesFound:int=0;
				var locationInArray:int;
	
				for (var i=0; i<=locationsArray.length-1; i++) {
					var typedLetters:int=this.firstViewMC.widgetFirstMC.txtCode.text.length;
	
					if (locationsArray[i].stad.substring(0,typedLetters).toLowerCase()==this.firstViewMC.widgetFirstMC.txtCode.text.toLowerCase()&&locationsArray[i].locationCode.substring(0,typedLetters).toLowerCase()!=this.firstViewMC.widgetFirstMC.txtCode.text.toLowerCase()) {
						citiesFound++;
						locationInArray=i;
					}
				}
	
				if (citiesFound==1) {
					this.firstViewMC.widgetFirstMC.txtCode.text=locationsArray[locationInArray].stad;
					this.firstViewMC.widgetFirstMC.txtCode.setSelection(0,locationsArray[locationInArray].stad.length);
				}
			}
		}

		private function loadWeer(code:String):void {
			var req:URLRequest=new URLRequest(rootPath+code+"&u=c");
			var ldr:URLLoader=new URLLoader();

			this.locationCode=code;
			this.tryCity=false;

			ldr.addEventListener(Event.COMPLETE, completeHandler);
			ldr.addEventListener(IOErrorEvent.IO_ERROR, faultHandler);

			ldr.load(req);
		}

		private function completeHandler(event:Event):void {
			weerXML=XML(event.currentTarget.data);
			//trace(weerXML);

			if (weerXML.channel.title.substr(17)!="Error") {
				this.firstViewMC.widgetFirstMC.txtStad.text=weerXML.channel.title.substr(17);
				var YNS:Namespace=weerXML.namespace("yweather");

				var we:Weer = new Weer();
				we.stad=this.firstViewMC.widgetFirstMC.txtStad.text;
				we.locationCode=this.locationCode.toLowerCase();

				this.firstViewMC.widgetFirstMC.tmpNow.text=weerXML.channel.item.YNS::condition.@temp+"°";
				this.firstViewMC.widgetFirstMC.txtCondition.text=getNdlCondition(weerXML.channel.item.YNS::condition.@text);

				this.firstViewMC.widgetFirstMC.tmpToday.text=weerXML.channel.item.YNS::forecast.@high[0]+"°      "+weerXML.channel.item.YNS::forecast.@low[0]+"°";
				this.firstViewMC.widgetFirstMC.tmpTomorrow.text=weerXML.channel.item.YNS::forecast.@high[1]+"°      "+weerXML.channel.item.YNS::forecast.@low[1]+"°";

				var codeNow:String=weerXML.channel.item.YNS::condition.@code;
				var codeTomorrow:String=weerXML.channel.item.YNS::forecast.@code[0];
				var codeToday:String=weerXML.channel.item.YNS::forecast.@code[1];
				
				this.firstViewMC.widgetFirstMC.txtCode.text="Voer stad of code in";
				this.firstViewMC.widgetFirstMC.txtCode.setSelection(0,0);
				
				var timeNow:String=weerXML.channel.item.YNS::condition.@date;
				var arrTimeNow:Array=timeNow.split(" ");
				var arrTimeNowHoursMinutes:Array=arrTimeNow[4].split(":");
				var sunrise:String=weerXML.channel.YNS::astronomy.@sunrise;// => 7:31 am
				var sunset:String=weerXML.channel.YNS::astronomy.@sunset;// => 5:21 pm
				var arrSunrise:Array=sunrise.split(" ");
				var arrSunset:Array=sunset.split(" ");
				var arrSunriseHoursMinutes:Array=arrSunrise[0].split(":");
				var arrSunsetHoursMinutes:Array=arrSunset[0].split(":");
				
				if(arrTimeNow[5]=="pm"){ arrTimeNowHoursMinutes[0]=Number(arrTimeNowHoursMinutes[0])+12; }
				
				trace(arrTimeNowHoursMinutes[0]+":"+arrTimeNowHoursMinutes[1]);
				trace(arrSunriseHoursMinutes[0]+":"+arrSunriseHoursMinutes[1]);
				trace((Number(arrSunsetHoursMinutes[0])+12)+":"+arrSunsetHoursMinutes[1]);
				
				if(Number(arrTimeNowHoursMinutes[0]) >= Number(arrSunsetHoursMinutes[0])+12 || Number(arrTimeNowHoursMinutes[0]) <= Number(arrSunriseHoursMinutes[0])){
					we.imagepathNow=rootPathImage+codeNow+"n.png";
				} else {
					we.imagepathNow=rootPathImage+codeNow+"d.png";
				}

				we.imagepathTomorrow=rootPathImage+codeTomorrow+"d.png";
				we.imagepathToday=rootPathImage+codeToday+"d.png";

				we.loadImageNow(this.firstViewMC.widgetFirstMC.imageNowMC);
				we.loadImageTomorrow(this.firstViewMC.widgetFirstMC.imageTomorrowMC);
				we.loadImageToday(this.firstViewMC.widgetFirstMC.imageTodayMC);

				this.firstViewMC.widgetFirstMC.imageNowMC.x=this.imageNowX;
				this.firstViewMC.widgetFirstMC.imageTodayMC.x=this.imageTodayX;
				this.firstViewMC.widgetFirstMC.imageTomorrowMC.x=this.imageTomorrowX;

				if (codeToday=="20") {
					this.firstViewMC.widgetFirstMC.imageTodayMC.x=this.firstViewMC.widgetFirstMC.imageTodayMC.x-16;
				}
				if (codeTomorrow=="20") {
					this.firstViewMC.widgetFirstMC.imageTomorrowMC.x=this.firstViewMC.widgetFirstMC.imageTomorrowMC.x-16;
				}
				if (codeNow=="20") {
					this.firstViewMC.widgetFirstMC.imageNowMC.x=this.firstViewMC.widgetFirstMC.imageNowMC.x-30;
				}

				if (codeToday=="31"||codeToday=="32") {
					this.firstViewMC.widgetFirstMC.imageTodayMC.x=this.firstViewMC.widgetFirstMC.imageTodayMC.x+8;
				}
				if (codeTomorrow=="31"||codeTomorrow=="32") {
					this.firstViewMC.widgetFirstMC.imageTomorrowMC.x=this.firstViewMC.widgetFirstMC.imageTomorrowMC.x+8;
				}
				if (codeNow=="31"||codeNow=="32") {
					this.firstViewMC.widgetFirstMC.imageNowMC.x=this.firstViewMC.widgetFirstMC.imageNowMC.x+25;
				}

				//Als het item al bestaat, eerst verwijderen
				var count2:int=0;

				for (var j=locationsArray.length-1; j>=0; j--) {
					if (locationsArray[j].locationCode==this.locationCode) {
						count2++;
						if (count2>0) {
							locationsArray.splice(j,1);
						}
					}
				}

				//weerobject in locationsArray pushen
				locationsArray.push(we);

				//wegschrijven naar harddisc
				setLocalData();
			} else if (this.tryCity==false) {
				tryCityHandler();
			} else {
				this.firstViewMC.widgetFirstMC.txtCode.text="Niet geldig";
				this.firstViewMC.widgetFirstMC.txtStad.text="Error";
			}
		}

		private function getNdlCondition(txt:String):String {
			txt=txt.toLowerCase();
			switch (txt) {
				case "tropical storm" :
					txt="tropische storm";
					break;
				case "hurricane" :
					txt="orkaan";
					break;
				case "severe thunderstorms" :
					txt="zware onweersbui";
					break;
				case "thunderstorms" :
					txt="onweer";
					break;
				case "mixed rain and snow" :
					txt="smeltende sneeuw";
					break;
				case "mixed rain and sleet" :
					txt="smeltende sneeuw";
					break;
				case "mixed snow and sleet" :
					txt="sneeuw en ijzel";
					break;
				case "freezing drizzle" :
					txt="ijzel";
					break;
				case "drizzle" :
					txt="motregen";
					break;
				case "freezing rain" :
					txt="ijzel";
					break;
				case "showers" :
					txt="buien";
					break;
				case "snow flurries" :
					txt="sneeuwval";
					break;
				case "light snow showers" :
					txt="lichte sneeuwval";
					break;
				case "blowing snow" :
					txt="stuifsneeuw";
					break;
				case "snow" :
					txt="sneeuw";
					break;
				case "hail" :
					txt="hagel";
					break;
				case "sleet" :
					txt="ijzel";
					break;
				case "dust" :
					txt="stof";
					break;
				case "foggy" :
					txt="mistig";
					break;
				case "mist" :
					txt="mistig";
					break;
				case "fog" :
					txt="mistig";
					break;
				case "haze" :
					txt="nevelig";
					break;
				case "smoky" :
					txt="stoffig";
					break;
				case "blustery" :
					txt="winderig";
					break;
				case "windy" :
					txt="winderig";
					break;
				case "cold" :
					txt="koud";
					break;
				case "cloudy" :
					txt="bewolkt";
					break;
				case "mostly cloudy" :
					txt="overwegend bewolkt";
					break;
				case "clear" :
					txt="helder";
					break;
				case "sunny" :
					txt="zonnig";
					break;
				case "fair" :
					txt="matig";
					break;
				case "mixed rain and hail" :
					txt="regen en hagel";
					break;
				case "hot" :
					txt="warm";
					break;
				case "isolated thunderstorms" :
					txt="plaatselijke onweersbuien";
					break;
				case "scattered thunderstorms" :
					txt="plaatselijk onweer";
					break;
				case "scattered showers" :
					txt="plaatselijke buien";
					break;
				case "heavy snow" :
					txt="zware sneeuwval";
					break;
				case "scattered snow showers" :
					txt="plaatselijk zware sneeuwval";
					break;
				case "partly cloudy" :
					txt="halfbewolkt";
					break;
				case "snow showers" :
					txt="sneeuwbuien";
					break;
			}
			return txt.substring(0,1).toUpperCase()+txt.substring(1,txt.length);
		}

		private function tryCityHandler():void {
			var code:String="";

			for (var i=0; i<=locationsArray.length-1; i++) {
				if (locationsArray[i].stad.toLowerCase()==this.firstViewMC.widgetFirstMC.txtCode.text.toLowerCase() || locationsArray[i].stad.toLowerCase()==(this.firstViewMC.widgetFirstMC.txtCode.text+", "+this.landCode as String).toLowerCase()) {
					code=locationsArray[i].locationCode;
				}
			}

			var req:URLRequest=new URLRequest(rootPath+code+"&u=c");
			var ldr:URLLoader=new URLLoader();

			this.locationCode=code;
			this.tryCity=true;

			ldr.addEventListener(Event.COMPLETE, completeHandler);
			ldr.addEventListener(IOErrorEvent.IO_ERROR, faultHandler);

			ldr.load(req);
		}

		private function setLocalData():void {
			var so:SharedObject=SharedObject.getLocal("iWeather");
			so.data.locations=locationsArray;

			//expliciet saven
			so.flush();
		}

		private function faultHandler(event:IOErrorEvent):void {
			this.firstViewMC.widgetFirstMC.txtStad.text="Error";
			this.firstViewMC.widgetFirstMC.txtCode.text="Geen internet";
			this.firstViewMC.widgetFirstMC.txtCode.setSelection(0,0);
		}

		private function dragHandler(event:MouseEvent):void {
			stage.nativeWindow.startMove();
		}

		private function codeHandler(event:MouseEvent):void {
			event.currentTarget.text="";
		}

		private function flipWidget(event:MouseEvent):void {
			this.firstViewMC.widgetFirstMC.optionsMC.removeEventListener(MouseEvent.MOUSE_UP,flipWidget);

			this.firstViewMC.x=this.iWeatherLeft-0.5;
			this.firstViewMC.y=this.iWeatherTop-0.5;
			this.firstViewMC.rotationY=0;
			TweenLite.to(this.firstViewMC,0.6,{rotationY:90,ease:Strong.easeIn,onComplete:flipWidgetEnd});
		}

		private function flipWidgetEnd():void {
			this.firstViewMC.visible=false;
			this.secondViewMC.visible=true;
			
			this.secondViewMC.x=iWeatherLeft;
			this.secondViewMC.y=iWeatherTop;
			this.secondViewMC.rotationY=-90;
			
			TweenLite.to(this.secondViewMC,1,{ease:Elastic.easeOut,x:iWeatherLeft-0.5,y:iWeatherTop-0.5,rotationY:0,onComplete:resetMatrix,onCompleteParams:[this.secondViewMC]});

			this.secondViewMC.widgetSecondMC.readyMC.addEventListener(MouseEvent.MOUSE_UP,flipWidgetBack);

			this.secondViewMC.widgetSecondMC.button1MC.buttonMode=true;
			this.secondViewMC.widgetSecondMC.button1MC.mouseChildren=false;
			this.secondViewMC.widgetSecondMC.button1MC.addEventListener(MouseEvent.MOUSE_DOWN,goToCity);
			this.secondViewMC.widgetSecondMC.button1MC.txtButton.text=locationsArray[locationsArray.length-1].stad;

			this.secondViewMC.widgetSecondMC.button2MC.buttonMode=true;
			this.secondViewMC.widgetSecondMC.button2MC.mouseChildren=false;
			this.secondViewMC.widgetSecondMC.button2MC.addEventListener(MouseEvent.MOUSE_DOWN,goToCity);
			this.secondViewMC.widgetSecondMC.button2MC.txtButton.text=locationsArray[locationsArray.length-2].stad;

			this.secondViewMC.widgetSecondMC.button3MC.buttonMode=true;
			this.secondViewMC.widgetSecondMC.button3MC.mouseChildren=false;
			this.secondViewMC.widgetSecondMC.button3MC.addEventListener(MouseEvent.MOUSE_DOWN,goToCity);
			this.secondViewMC.widgetSecondMC.button3MC.txtButton.text=locationsArray[locationsArray.length-3].stad;

			this.secondViewMC.widgetSecondMC.button4MC.buttonMode=true;
			this.secondViewMC.widgetSecondMC.button4MC.mouseChildren=false;
			this.secondViewMC.widgetSecondMC.button4MC.addEventListener(MouseEvent.MOUSE_DOWN,goToCity);
			this.secondViewMC.widgetSecondMC.button4MC.txtButton.text=locationsArray[locationsArray.length-4].stad;

			this.secondViewMC.widgetSecondMC.button5MC.buttonMode=true;
			this.secondViewMC.widgetSecondMC.button5MC.mouseChildren=false;
			this.secondViewMC.widgetSecondMC.button5MC.addEventListener(MouseEvent.MOUSE_DOWN,goToCity);
			this.secondViewMC.widgetSecondMC.button5MC.txtButton.text=locationsArray[locationsArray.length-5].stad;

			this.secondViewMC.widgetSecondMC.button6MC.buttonMode=true;
			this.secondViewMC.widgetSecondMC.button6MC.mouseChildren=false;
			this.secondViewMC.widgetSecondMC.button6MC.addEventListener(MouseEvent.MOUSE_DOWN,goToCity);
			this.secondViewMC.widgetSecondMC.button6MC.txtButton.text=locationsArray[locationsArray.length-6].stad;

			this.secondViewMC.widgetSecondMC.button1MC.alpha=0.5;
			this.secondViewMC.widgetSecondMC.button2MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button3MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button4MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button5MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button6MC.alpha=1;

			this.secondViewMC.widgetSecondMC.twitterBtnMC.buttonMode=true;
			this.secondViewMC.widgetSecondMC.twitterBtnMC.mouseChildren=false;
			this.secondViewMC.widgetSecondMC.txtTwitterText.text=this.firstViewMC.widgetFirstMC.txtStad.text+": "+this.firstViewMC.widgetFirstMC.txtCondition.text+" en "+this.firstViewMC.widgetFirstMC.tmpNow.text;
			this.secondViewMC.widgetSecondMC.twitterBtnMC.addEventListener(MouseEvent.MOUSE_DOWN,postOnTwitter);
			
			this.secondViewMC.widgetSecondMC.txtTwitterUsername.addEventListener(MouseEvent.MOUSE_DOWN,txtTwitterHandler);
			this.secondViewMC.widgetSecondMC.txtTwitterWachtwoord.addEventListener(MouseEvent.MOUSE_DOWN,txtTwitterHandler);
			this.secondViewMC.widgetSecondMC.txtTwitterWachtwoord.displayAsPassword = true;
			
			this.secondViewMC.widgetSecondMC.txtTwitterUsername.addEventListener(KeyboardEvent.KEY_DOWN,keyHandlerTwitter);
			this.secondViewMC.widgetSecondMC.txtTwitterWachtwoord.addEventListener(KeyboardEvent.KEY_DOWN,keyHandlerTwitter);

			this.isFlipped=true;
		}
		
		private function keyHandlerTwitter(event:KeyboardEvent):void {
			if (event.keyCode==Keyboard.ENTER){
				postOnTwitter();
			}
		}
		
		private function txtTwitterHandler(event:MouseEvent):void {
			if(event.currentTarget.text=="Wachtwoord" || event.currentTarget.text=="Gebruikersnaam" || event.currentTarget.text=="Mislukt"){
				event.currentTarget.text="";
			}
			
		}

		private function postOnTwitter(event:MouseEvent = null):void {
			var swx:SWX = new SWX();
			swx.gateway="http://swxformat.org/php/swx.php";
			swx.encoding="POST";
			swx.debug=true;
			if (this.secondViewMC.widgetSecondMC.txtTwitterUsername.text!="Gebruikersnaam"&&this.secondViewMC.widgetSecondMC.txtTwitterWachtwoord.text!="Wachtwoord"&&this.secondViewMC.widgetSecondMC.txtTwitterWachtwoord.text!=""&&this.secondViewMC.widgetSecondMC.txtTwitterUsername.text!=""&&this.secondViewMC.widgetSecondMC.txtTwitterUsername.text!="Mislukt") {
				try {
					var callParameters:Object =
					{
					serviceClass: "Twitter",
					method: "update",
					args: [this.secondViewMC.widgetSecondMC.txtTwitterText.text,this.secondViewMC.widgetSecondMC.txtTwitterUsername.text,this.secondViewMC.widgetSecondMC.txtTwitterWachtwoord.text]
					};
					swx.call(callParameters);
					navigateToURL(new URLRequest("http://twitter.com/"+this.secondViewMC.widgetSecondMC.txtTwitterUsername.text));
				} catch (error:Error) {
					this.secondViewMC.widgetSecondMC.txtTwitterUsername.text="Mislukt";
					this.secondViewMC.widgetSecondMC.txtTwitterwachtwoord.text="Wachtwoord";
				}
			} else {
				this.secondViewMC.widgetSecondMC.txtTwitterUsername.text="Mislukt";
				this.secondViewMC.widgetSecondMC.txtTwitterWachtwoord.text="Wachtwoord";
			}
		}

		private function goToCity(event:MouseEvent):void {
			var code:String;
			for (var i=0; i<=locationsArray.length-1; i++) {
				if (locationsArray[i].stad==event.currentTarget.txtButton.text) {
					code=locationsArray[i].locationCode;
				}
			}

			event.currentTarget.addEventListener(MouseEvent.MOUSE_UP,buttonMouseUp);

			loadWeer(code);
		}

		private function buttonMouseUp(event:MouseEvent):void {
			this.secondViewMC.widgetSecondMC.button1MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button2MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button3MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button4MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button5MC.alpha=1;
			this.secondViewMC.widgetSecondMC.button6MC.alpha=1;

			event.currentTarget.alpha=0.5;
			
			flipWidgetBack(event);
		}

		private function flipWidgetBack(event:MouseEvent):void {
			this.secondViewMC.widgetSecondMC.readyMC.removeEventListener(MouseEvent.MOUSE_UP,flipWidgetBack);

			this.secondViewMC.widgetSecondMC.button1MC.removeEventListener(MouseEvent.MOUSE_UP,goToCity);
			this.secondViewMC.widgetSecondMC.button2MC.removeEventListener(MouseEvent.MOUSE_UP,goToCity);
			this.secondViewMC.widgetSecondMC.button3MC.removeEventListener(MouseEvent.MOUSE_UP,goToCity);
			this.secondViewMC.widgetSecondMC.button4MC.removeEventListener(MouseEvent.MOUSE_UP,goToCity);
			this.secondViewMC.widgetSecondMC.button5MC.removeEventListener(MouseEvent.MOUSE_UP,goToCity);
			this.secondViewMC.widgetSecondMC.button6MC.removeEventListener(MouseEvent.MOUSE_UP,goToCity);
			this.secondViewMC.widgetSecondMC.twitterBtnMC.removeEventListener(MouseEvent.MOUSE_DOWN,postOnTwitter);

			this.secondViewMC.x=this.iWeatherLeft-0.5;
			this.secondViewMC.y=this.iWeatherTop-0.5;
			
			this.secondViewMC.rotationY=360;
			TweenLite.to(this.secondViewMC,0.6,{ease:Strong.easeIn,rotationY:270,onComplete:flipWidgetBackEnd});
		}

		private function flipWidgetBackEnd():void {
			this.secondViewMC.visible=false;
			this.firstViewMC.visible=true;
			
			this.secondViewMC.x=iWeatherLeft+0.5;
			this.secondViewMC.y=iWeatherTop+0.5;
			
			TweenLite.to(this.secondViewMC,1,{ease:Elastic.easeOut,x:iWeatherLeft,y:iWeatherTop});
			
			this.firstViewMC.rotationY=90;
			TweenLite.to(this.firstViewMC,1,{ease:Elastic.easeOut,rotationY:0,onComplete:resetMatrix,onCompleteParams:[this.firstViewMC]});

			this.firstViewMC.widgetFirstMC.optionsMC.addEventListener(MouseEvent.MOUSE_UP,flipWidget);

			this.isFlipped=false;
		}

		private function closeNow(event:MouseEvent):void {
			closeWidget();
		}

		private function closeWidget():void {
			if (isFlipped==true) {
				TweenLite.to(this.secondViewMC.widgetSecondMC,0.35,{ease:Quad.easeIn,scaleX:0,scaleY:0,y:closeTop+(closeHeight/2),x:closeLeft+(closeWidth/2)});
				TweenLite.to(this.secondViewMC.closeMC,0.25,{delay:0.15,ease:Strong.easeIn,scaleX:0,scaleY:0,y:closeTop+(closeHeight/2),x:closeLeft+(closeWidth/2),onComplete:finalClose});
			} else {
				TweenLite.to(this.firstViewMC.widgetFirstMC,0.35,{ease:Quad.easeIn,scaleX:0,scaleY:0,y:closeTop+(closeHeight/2),x:closeLeft+(closeWidth/2)});
				TweenLite.to(this.firstViewMC.closeMC,0.25,{delay:0.15,ease:Strong.easeIn,scaleX:0,scaleY:0,y:closeTop+(closeHeight/2),x:closeLeft+(closeWidth/2),onComplete:finalClose});
			}
		}

		private function finalClose():void {
			stage.nativeWindow.close();
		}

	}

}